Bug 993456 - Review Request: metslib - Metaheuristic modeling framework and optimization toolkit in modern C++
Summary: Review Request: metslib - Metaheuristic modeling framework and optimization t...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Orion Poplawski
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 993457
TreeView+ depends on / blocked
 
Reported: 2013-08-06 01:29 UTC by Rich Mattes
Modified: 2013-09-09 23:55 UTC (History)
3 users (show)

Fixed In Version: metslib-0.5.3-4.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-09-09 23:55:13 UTC
orion: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Rich Mattes 2013-08-06 01:29:41 UTC
Spec URL: http://rmattes.fedorapeople.org/RPMS/metslib/metslib.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/metslib/metslib-0.5.3-1.fc19.src.rpm
Description:
METSlib is a metaheuristic modeling framework and optimization toolkit in
modern C++ released as Free/Libre/Open Source Software.

Model and algorithms are modular: any search algorithm can be applied to the
same model. On the other hand no assumption is made on the model, you can
work on any problem type: timetabling, assignment problems, vehicle routing,
bin-packing and so on.

Once you have implemented your model in the problem framework, the library
makes easy testing different Tabu Search strategies or even different
algorithms (Simulated Annealing or other local search based algorithms) with
a few lines of code.

 
Fedora Account System Username: rmattes

rpmlint:
$ rpmlint metslib.spec ../RPMS/noarch/metslib-devel-0.5.3-1.fc19.noarch.rpm 
metslib-devel.noarch: W: spelling-error Summary(en_US) Metaheuristic -> Meta heuristic, Meta-heuristic, Heuristics
metslib-devel.noarch: W: spelling-error %description -l en_US metaheuristic -> meta heuristic, meta-heuristic, heuristics
1 packages and 1 specfiles checked; 0 errors, 2 warnings.

Comment 1 Joshua Small 2013-08-07 02:39:57 UTC
Hi,

This is an informal review as I cannot sponsor.

I have run a koji build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5787741

I did notice a build error:
configure: WARNING: unrecognized options: --disable-static
Although this flag is often recommended, as I'm seeing that the configure script doesn't recognise it, it should probably be removed.

There appears to be a significant amount of documentation that may be better served by a separate -doc rpm.

rpmlint looks clean.

I noted Source0 expands to http://www.coin-or.org/download/source/metslib-0.5.3.tgz, which currently provides a 404 error for me.

These minor points are the only ones I have been able to raise.

Comment 2 Michael Schwendt 2013-08-07 10:11:15 UTC
Packages aren't sponsored, people are. ;-)


> BuildArch:      noarch

Mixed feelings here. This is another header-only API with nothing in the guidelines about that. I'd build it arch-specific like Joshua does for his libscrypt submission, because the test-suite involves compiling test programs. That would be the only way to run the test-suite for all target archs.

Note that you could still build a metslib-devel.noarch package when moving the BuildArch tag into the subpackage definition. Making sure that no arch-specific files get included in that noarch package would be your responsibility (as before).


> License:        GPLv3 or CPL

The source files claim "or later": GPLv3+
Please double-check.
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#.22or_later_version.22_licenses

A copy of the CPL license text is not included:
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text


> ./metslib/abstract-search.hh

Contains only a CPL preamble and doesn't mention GPL. Could you contact upstream for license clarification?


> Provides:       %{name} = %{version}-%{release}

Mixed feelings here, too. I would drop this particular virtual package name. You give packagers the choice to depend on _three_ different names, e.g. in BuildRequires: metslib, metslib-devel, metslib-static
That complicates queries done with repoquery or other tools.


> find %{buildroot} -name '*.la' -exec rm -f {} ';'

Superfluous, since no libtool archive files gets build or installed.


> %check
> make test

It overrides Fedora's optflags with -O3.
https://fedoraproject.org/wiki/Packaging:Guidelines#Compiler_flags


> Move pkgconfig file to /usr/share/pkgconfig (since package is noarch)

Usually I review pkgconfig files. It contains a wrong libdir definition. Even if it were not used, one can retrieve it with pkgconfig:

  $ pkg-config --variable=libdir metslib
  /usr/lib

And the wrong libdir is used in the CFLAGS, too:

  $ pkg-config --cflags metslib
  -I/usr/include/metslib-0.5 -I/usr/lib/metslib-0.5/include

Comment 3 Michael Schwendt 2013-08-07 10:37:58 UTC
Forgot to mention that /usr/lib/metslib-0.5/include is not used by the package at all.

Comment 4 Michael Schwendt 2013-08-07 16:40:52 UTC
Did I write "libscrypt" above? Memory failure. ;) Meant "ell" -> bug 993324

Comment 5 Rich Mattes 2013-08-11 16:59:53 UTC
Thanks for taking a look.  Updated packages:

Spec URL: http://rmattes.fedorapeople.org/RPMS/metslib/metslib.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/metslib/metslib-0.5.3-2.fc19.src.rpm

I submitted a bug report upstream asking for clarification of the abstract_search.hh license:
https://projects.coin-or.org/metslib/ticket/3
I will also ask about including a copy of the license text.

As far as the BuildArch: goes, we ran into the same sort of issue with the eigen3 package recently.  It is good to be able to run the unit tests on all architectures, but there isn't a need to have arch specific packages.  We ended up doing what you suggested: only marking the -devel package as noarch, so that all builders will run the unit tests, and disabling the debuginfo generation since there are no binaries to strip.  I did the same to this package.

I provided %{name} = %{version}-%{release} more for convenience at install-time rather than for packaging purposes.  I agree it's not really necessary though so I removed it.

The -O3 and .la removal have been fixed.  I also removed all references to the libdir from the pkgconfig file (they're not necessary.)


$ rpmlint metslib.spec ../RPMS/noarch/metslib-devel-0.5.3-2.fc19.noarch.rpm 
metslib-devel.noarch: W: spelling-error Summary(en_US) Metaheuristic -> Meta heuristic, Meta-heuristic, Heuristics
metslib-devel.noarch: W: spelling-error %description -l en_US metaheuristic -> meta heuristic, meta-heuristic, heuristics
1 packages and 1 specfiles checked; 0 errors, 2 warnings.

Comment 6 Orion Poplawski 2013-08-22 22:50:57 UTC
Modify configure instead of configure.ac to remove -O3 to avoid having to regenerate configure.

Comment 7 Rich Mattes 2013-08-22 23:53:03 UTC
Good call.  I changed the sed statement, update is here:

Spec URL: http://rmattes.fedorapeople.org/RPMS/metslib/metslib.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/metslib/metslib-0.5.3-3.fc19.src.rpm

rpmlint:
$ rpmlint metslib.spec ../RPMS/noarch/metslib-devel-0.5.3-3.fc19.noarch.rpm 
metslib-devel.noarch: W: spelling-error Summary(en_US) Metaheuristic -> Meta heuristic, Meta-heuristic, Heuristics
metslib-devel.noarch: W: spelling-error %description -l en_US metaheuristic -> meta heuristic, meta-heuristic, heuristics
1 packages and 1 specfiles checked; 0 errors, 2 warnings.

scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5843846

Comment 8 Orion Poplawski 2013-08-23 05:09:00 UTC
FYI - I've filed https://fedorahosted.org/fpc/ticket/337 to discuss header only libraries a bit more.

Comment 9 Orion Poplawski 2013-08-23 15:38:16 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Large documentation must go in a -doc subpackage.
  Note: Documentation size is 3123200 bytes in 445 files.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation

- It should require libstdc++-devel

- License should be GPLv3+ or CPL

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[!]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[-]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in metslib-
     devel
[x]: Package complies to the Packaging Guidelines
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v3 or later)", "Unknown or generated". 8 files have unknown
     license. Detailed output of licensecheck in
     /export/home/orion/redhat/metslib-0.5.3/review-metslib/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: metslib-devel-0.5.3-3.fc19.noarch.rpm
metslib-devel.noarch: W: spelling-error Summary(en_US) Metaheuristic -> Meta heuristic, Meta-heuristic, Heuristics
metslib-devel.noarch: W: spelling-error %description -l en_US metaheuristic -> meta heuristic, meta-heuristic, heuristics
1 packages and 0 specfiles checked; 0 errors, 2 warnings.



Requires
--------
metslib-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config



Provides
--------
metslib-devel:
    metslib-devel
    metslib-static
    pkgconfig(metslib)



Source checksums
----------------
http://www.coin-or.org/download/source/metslib/metslib-0.5.3.tgz :
  CHECKSUM(SHA256) this package     : 33142aa3be7c79b966a14c50eb39d0468e98ff365f5c7e055a93ea77eda04c3d
  CHECKSUM(SHA256) upstream package : 33142aa3be7c79b966a14c50eb39d0468e98ff365f5c7e055a93ea77eda04c3d


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29

Comment 10 Michael Schwendt 2013-08-23 15:45:40 UTC
It need not require libstdc++-devel, since gcc-c++ (and its deps) is considered part of the minimum build environment:
https://fedoraproject.org/wiki/Packaging:Guidelines#Exceptions_2

Comment 11 Orion Poplawski 2013-08-23 15:48:28 UTC
(In reply to Michael Schwendt from comment #10)
> It need not require libstdc++-devel, since gcc-c++ (and its deps) is
> considered part of the minimum build environment:
> https://fedoraproject.org/wiki/Packaging:Guidelines#Exceptions_2

I'm not asking to BR it, but to Require it.  I can go either way, but plenty of other packages do it and it makes sense to me.

Comment 12 Michael Schwendt 2013-08-23 17:33:18 UTC
That's nothing different. The exceptions also apply to ordinary installations. For compiling C/C++ code, a compiler is needed. gcc-c++ pulls in libstdc++-devel, gcc pulls in cpp and glibc-devel, and we don't Requires glibc-devel in all C based -devel packages either.

> plenty of other packages do it 

It's a [minor] packaging mistake for most of them:

$ repoquery --whatrequires libstdc++-devel --exactdeps|grep -v i686
armadillo-devel-0:3.910.0-1.fc20.x86_64
clang-0:3.3-0.8.rc3.fc20.x86_64
fltk-devel-0:1.3.0-11.fc20.x86_64
gcc-c++-0:4.8.1-6.fc20.x86_64
libEMF-devel-0:1.0.7-3.fc20.x86_64
llvm-devel-0:3.3-0.8.rc3.fc20.x86_64
zipios++-devel-0:0.1.5.9-10.fc20.x86_64

$ repoquery --whatrequires glibc-devel --exactdeps|grep -v i686|grep -v glibc|grep -v gcc|wc -l
9
$ repoquery --whatrequires gcc-c++ --exactdeps|grep -v i686|wc -l
13
$ repoquery --whatrequires gcc --exactdeps|grep -v ^gcc|grep -v i686|wc -l
34

Comment 13 Orion Poplawski 2013-08-23 17:41:09 UTC
Okay, sounds good.

Comment 14 Rich Mattes 2013-08-24 16:41:34 UTC
I added a -doc subpackage, and changed the license field to GPLv3+ instead of GPLv3.  You can find the update here:

Spec URL: http://rmattes.fedorapeople.org/RPMS/metslib/metslib.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/metslib/metslib-0.5.3-4.fc19.src.rpm

$ rpmlint metslib.spec ../RPMS/noarch/metslib-*
metslib-devel.noarch: W: spelling-error Summary(en_US) Metaheuristic -> Meta heuristic, Meta-heuristic, Heuristics
metslib-devel.noarch: W: spelling-error %description -l en_US metaheuristic -> meta heuristic, meta-heuristic, heuristics
2 packages and 1 specfiles checked; 0 errors, 2 warnings.

Comment 15 Orion Poplawski 2013-08-25 03:44:04 UTC
Looks good.  Approved.

Comment 16 Rich Mattes 2013-08-25 16:01:35 UTC
Thanks for the review!

New Package SCM Request
=======================
Package Name: metslib
Short Description: Metaheuristic modeling framework and optimization toolkit in modern C++
Owners: rmattes
Branches: f18 f19 f20 el6
InitialCC:

Comment 17 Gwyn Ciesla 2013-08-26 12:22:35 UTC
Git done (by process-git-requests).

Comment 18 Fedora Update System 2013-08-27 00:43:53 UTC
metslib-0.5.3-4.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/metslib-0.5.3-4.fc19

Comment 19 Fedora Update System 2013-08-27 23:36:05 UTC
metslib-0.5.3-4.fc19 has been pushed to the Fedora 19 testing repository.

Comment 20 Fedora Update System 2013-09-09 23:55:13 UTC
metslib-0.5.3-4.fc19 has been pushed to the Fedora 19 stable repository.


Note You need to log in before you can comment on or make changes to this bug.